# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/1/31
"""
看一看+小程序: 朋友圈榜单执行入口
"""
import datetime
import sys
import os
import time
import argparse
sys.path.append(os.getcwd())
from common.common import Common
from common.feishu import Feishu
from kanyikan.kanyikan_moment.kanyikan_moment import Moment


def main(log_type, crawler, strategy, oss_endpoint, env, machine):
    """
    主函数入口
    :param log_type: 日志命名: monent
    :param crawler: 哪款爬虫: kanyikan
    :param strategy: 爬虫策略: kanyikan_moment
    :param machine: 爬虫运行机器，阿里云服务器: aliyun_hk / aliyun / macpro / macair / local
    :param env: 正式环境: prod；测试环境: dev
    :param oss_endpoint: 阿里云102服务器: inner ；其它: out
    :return: None
    """
    while True:
        if 1 >= datetime.datetime.now().hour >= 0:
            pass
        else:
            moment_video_list = Feishu.get_sheet_content(log_type, crawler, 'iK58HX')
            for moment_video_id in moment_video_list:
                Common.logger(log_type, crawler).info(f"开始抓取{moment_video_id}朋友圈推荐视频\n")
                Moment.get_videos(log_type, crawler, strategy, oss_endpoint, env, machine, moment_video_id)

            Common.del_logs(log_type, crawler)
            Common.logger(log_type, crawler).info("抓取完一轮，休眠 10 秒\n")
            time.sleep(10)


if __name__ == "__main__":
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler')  ## 添加参数
    parser.add_argument('--strategy')  ## 添加参数
    parser.add_argument('--our_uid')  ## 添加参数
    parser.add_argument('--oss_endpoint')  ## 添加参数
    parser.add_argument('--env')  ## 添加参数
    parser.add_argument('--machine')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    # print(args)
    main(log_type=args.log_type,
         crawler=args.crawler,
         strategy=args.strategy,
         oss_endpoint=args.oss_endpoint,
         env=args.env,
         machine=args.machine)
