# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/2/27
import argparse
# import os
# import sys
# import time

# sys.path.append(os.getcwd())
from common.common import Common
# from common.feishu import Feishu
from kuaishou.kuaishou_follow.kuaishou_follow import Follow


def main(log_type, crawler, strategy, oss_endpoint, env, machine):
    while True:
        try:
            Common.logger(log_type, crawler).info('开始抓取 快手 定向榜\n')
            Follow.get_follow_videos(log_type=log_type,
                                     crawler=crawler,
                                     strategy=strategy,
                                     oss_endpoint=oss_endpoint,
                                     env=env,
                                     machine=machine)
            Common.del_logs(log_type, crawler)
            Common.logger(log_type, crawler).info('抓取完一轮\n')
            break
        except Exception as e:
            Common.logger(log_type, crawler).info(f"快手定向榜异常，触发报警:{e}\n")
            # Feishu.bot(log_type, crawler, f"快手定向榜异常，触发报警:{e}")


if __name__ == "__main__":
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler')  ## 添加参数
    parser.add_argument('--strategy')  ## 添加参数
    parser.add_argument('--our_uid')  ## 添加参数
    parser.add_argument('--oss_endpoint')  ## 添加参数
    parser.add_argument('--env')  ## 添加参数
    parser.add_argument('--machine')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    # print(args)
    main(log_type=args.log_type,
         crawler=args.crawler,
         strategy=args.strategy,
         oss_endpoint=args.oss_endpoint,
         env=args.env,
         machine=args.machine)